function [Betti0, Betti1] = calculateBettiNumbers(gold, contourOrAll, illustrate)

if nargin == 4
    M = rand(1000,3);
end

if strcmp(contourOrAll, 'contour')
    bnd = findContourMap(gold, 'eight');
else
    bnd = gold > 0;
end
cnt = 1;
while sum(sum(bnd == 0)) > 0
    % to be the same connected component, four-connectivity is required
    [cc0, no0] = bwlabeln(bnd, 4);
    % to be considered as a hole, eight-neighbors should be foreground
    tmp = imfill(bnd, 8, 'holes');
    [holes0, no1] = bwlabeln(tmp > 0 & bnd == 0);
    
    if nargin == 4
        figure, imshow(label2rgb(cc0, M));
        figure, imshow(label2rgb(holes0, M));
        fprintf('%d\t%d\n', no0, no1);
    end

    Betti0(cnt) = no0;
    Betti1(cnt) = no1;
    
    cnt = cnt + 1;
    bnd = increaseDistance(bnd);
end

ftime = size(Betti1, 2);
for t = ftime : -1: 1
   if Betti0(t) ~= 1 || Betti1(t) ~= 0
       break
   end
end
if t < ftime
    t = t + 1;
end
Betti0 = Betti0(1, 1:t);
Betti1 = Betti1(1, 1:t);

end
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%
% Thickens the boundary pixels by one towards their four neignbors     %
%----------------------------------------------------------------------%
function res = increaseDistance(bnd)

[dx, dy] = size(bnd);
res = bnd;
for i = 1 : dx
    for j = 1 : dy
        if bnd(i, j) == 0
            if i > 1 && bnd(i - 1, j) == 1
                res(i, j) = 1;
            elseif i < dx && bnd(i + 1, j) == 1
                res(i, j) = 1;
            elseif j > 1 && bnd(i, j - 1) == 1
                res(i, j) = 1;
            elseif j < dy && bnd(i, j + 1) == 1
                res(i, j) = 1;
            end
        end
    end
end

end
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%
