function visualizeBarcodes(H0_BirthTime, H0_DeathTime, H1_BirthTime, H1_DeathTime, offset)

fontSize = 28; % 20
markerSize = 32; %18

if size(H1_DeathTime, 1) > 0
    lastTime = max(H1_DeathTime);
else
    lastTime = max(H0_DeathTime);
end

h0no = size(H0_BirthTime, 1);
d0(:, 2) = H0_BirthTime;
d0(:, 1) = H0_DeathTime;
for i = 1 : h0no
    if d0(i, 1) == 0
        d0(i, 1) = lastTime + 1;
    end
end
d0 = sortrows(d0, 'descend');

d1(:, 1) = H1_BirthTime;
d1(:, 2) = H1_DeathTime;
d1 = sortrows(d1, 'ascend');

d0 = d0 - 1;
d1 = d1 - 1;

compNo = size(d0, 1);
holeNo = size(d1, 1);
YSize = compNo + holeNo + 1;

figure
cnt1 = 0;
for i = 1 : compNo
    rectangle('Position', [d0(i, 2)     YSize       d0(i, 1)-d0(i, 2)    0.8], 'FaceColor', [1 0 0])
    cnt1 = cnt1 + YSize;
    YSize = YSize - 1;
end
cnt1 = cnt1 / compNo;
YSize = YSize - 1;
for i = 1 : holeNo
    rectangle('Position', [d1(i, 1)     YSize       d1(i, 2)-d1(i, 1)    0.8], 'FaceColor', [0 0.4470 0.7410])
    YSize = YSize - 1;
end

h = gca;
set(h, 'YTickLabel', [], 'YTick', [], 'FontSize', fontSize);
axis([0 max(max(d0)) -1 compNo+holeNo+3])
xlabel('Filtreleme zamanı')
midPoint = (compNo + holeNo + 1) / 2;
text(lastTime-offset, midPoint, 'Bileşen (0-Betti)', 'FontSize', fontSize, 'Color', [1 0 0])
text(lastTime-offset, midPoint-2.5, 'Delik (1-Betti)', 'FontSize', fontSize, 'Color', [0 0.4470 0.7410])

%figure, subplot(1,2,1),bar(d0(2:end, 1), 'grouped', 'Horizontal', 'on'); 
%h = gca; set(h, 'YTickLabel', [], 'YTick', [], 'FontSize', fontSize);
%xlabel('Filtreleme zamanı')
%title('0-Betti')

figure
plot(d0(:, 2), d0(:, 1), 'r.', 'MarkerSize', markerSize)
hold on
plot(d1(:, 1), d1(:, 2), 'Color', [0 0.4470 0.7410], 'Marker', '.', 'MarkerSize', markerSize, 'LineStyle', 'none')
plot([-1 lastTime], [-1 lastTime], 'k--', 'LineWidth', 1.5)
axis([-1 lastTime+1 -1 lastTime+1])
h = gca;
set(h, 'FontSize', fontSize);
xlabel('Doğum zamanı')
ylabel('Ölüm zamanı')
if size(H1_DeathTime, 1) == 0
    legend('Bileşen (0-Betti)', '\infty', 'Location', 'southeast')
else
    legend('Bileşen (0-Betti)', 'Delik (1-Betti)', '\infty', 'Location', 'southeast')
end

end
